# generator-umu [![NPM version][npm-image]](https://www.npmjs.com/package/generator-umu) [![Dependency Status][daviddm-image]](https://david-dm.org/umu-team/generator-umu.svg)
> UMU 前端模板代码生成器

## 安装

```bash
npm install -g yo generator-umu
```

## 使用

本工具可生成页面，前端路由子页面及组件三种类型的模板代码。

- 仓库根目录运行，会校验当前目录环境
- 支持 PC 端及 M 端页面，根据当前目录自动检测。
- 包含命名冲突的检测，如果需要生成的页面或组件已经存在则会提示
- 组件支持生成共用的组件或者路由页面独自两种，存放目录不同。

### 生成页面

生成一个全新的页面，从 php 模板到 react 示例页面。

```bash
yo umu [page name]
```

### 生成路由子页面

生成一个前端路由子页面。

```bash
yo umu:routePage [route page name]
```

或者使用缩写形式：

```bash
yo umu:rp [route page name]
```

### 生成组件

生成 react 组件。

```bash
yo umu:component [component name]
```

### 其他

- 查看帮助

```bash
yo umu -h
yo umu:rp -h
yo umu:cp -h
```

## 相关资源

- [Yeoman generator api documentation](http://yeoman.io/generator/)
- [Tutorial for authoring a generator](http://yeoman.io/authoring/)
- [generator-generator](https://github.com/yeoman/generator-generator)
- [Available prompt options](https://github.com/SBoudrias/Inquirer.js)
- [fs documentation](https://github.com/sboudrias/mem-fs-editor)
- rename file name with copyTpl
  - [Listing files.](https://github.com/SBoudrias/mem-fs-editor/issues/67)
  - [Allow renaming on glob copy?](https://github.com/SBoudrias/mem-fs-editor/issues/43)


## 许可协议

MIT © [UMU](https://www.umu.com/)

[npm-image]: https://badge.fury.io/js/generator-umu.svg
[npm-url]: https://npmjs.org/package/generator-umu
[travis-image]: https://travis-ci.org/wayou/generator-umu.svg?branch=master
[travis-url]: https://travis-ci.org/wayou/generator-umu
[daviddm-image]: https://david-dm.org/wayou/generator-umu.svg?theme=shields.io
[daviddm-url]: https://david-dm.org/wayou/generator-umu
