/**
 * @description
 * @author <%= author %>
 * @date <%= date %>
 */

const { ReactDOM, React, Redux, ReduxSaga } = window;
const Provider = ReactRedux.Provider;
const {
    Route,
    Router,
    Link,
    hashHistory,
    Redirect,
    IndexLink,
    IndexRoute,
} = ReactRouter;

import * as Common from '/common/services/common';
import overrideConsole from '/util/console.es6';
import { getPageData, getData, setPageData } from '/util/util.es6';

import PageModel from '/common/services/pageModel.es6';
import indexReducer from '/page/courseCategory/indexReducer.es6';
import indexAction from '/page/courseCategory/indexAction.es6';

import rootSaga from 'page/courseCategory/rootSaga.es6';
import indexPage from 'page/<%= pageName %>/routePage/indexPage/indexPage.es6';

import ContentWrapper from '/common/components/contentWrapper.es6';
import { Header } from 'common/components/header/header.es6';

let pageModel = PageModel(indexAction, indexReducer);

function createStore(data) {
    let sagaMiddleWare = ReduxSaga.default({});
    pageModel.createStore({
        pageData: {
            userInfo: data.userInfo,
            teacherInfo: data.teacherInfo
        },
        indexPage: {
            foo: 'foo'
        }
    }, [sagaMiddleWare]);
    sagaMiddleWare.run(rootSaga);
}

function renderApp(data) {
    const store = pageModel.getStore();
    let index = pageModel.connectContainer(indexPage, 'indexPage');
    ReactDOM.render(
        <Provider store={store}>
            <Router history={hashHistory}>
                <Redirect from="/" to="/indexPage" />
                <Route path="indexPage" component={index} />
                <Route path="*" component={index} />
            </Router>
        </Provider>,
        document.querySelector('.doc')
    );
}

export function init(data) {
    overrideConsole();
    setPageData(data);
    createStore(data);
    renderApp(data);
}
