/**
 * @description
 * @author <%= author %>
 * @date <%= date %>
 */

var commonModule = require('common/commonModule');
var main = angular.module('main', [commonModule.name]);
//service
require('util/statistics');
require('services/<%= pageName %>DataService');

require('components/sampleComponent/sampleComponent');

require('route');

main.config([
    '$controllerProvider',
    '$compileProvider',
    '$filterProvider',
    '$provide',
    'standardizeSearchProvider',
    function (
        $controllerProvider,
        $compileProvider,
        $filterProvider,
        $provide,
        standardizeSearchProvider
    ) {
        var registerMap = {
            'controller': $controllerProvider.register,
            'directive': $compileProvider.directive,
            'component': $compileProvider.component,
            'filter': $filterProvider.register,
            'factory': $provide.factory,
            'service': $provide.service
        };

        angular.forEach(registerMap, function (registerProvider, register) {
            main[register] = function () {
                return registerProvider.apply(main, arguments);
            }
        });

    }
]);

main.run([
    '$rootScope',
    'util',
    '$location',
    '$timeout',
    'pageInit',
    function (
        $rootScope,
        util,
        $location,
        $timeout,
        pageInit
    ) {
        pageInit();
    }
]);

// 主程序
main.controller('mainController', [
    '$rootScope',
    '$scope',
    '$state',
    function (
        $rootScope,
        $scope,
        $state
    ) {
    }]);

angular.bootstrap(document, ['main']);
