/**
 * @description
 * @author <%= author %>
 * @date <%= date %>
 */

import actionType from 'util/actionType.es6';
import * as $ from 'common/services/zeptoWrapper';
import <%= pageName %>DataService from '../../services/<%= pageName %>DataService.es6';
import { parseNum } from '/util/util.es6';

const { ReduxSaga } = window
const { delay } = ReduxSaga;
const { take, fork, race, call, put, takeEvery, takeLatest, select, cancel } = ReduxSaga.effects;

function* requestData(param) {
    try {
        return yield <%= pageName %>DataService.sampleAjax(param).then((response) => {
            return response;
        }, (...args) => {
            //exception
            if (args[0] && args[0].promise) {
                return args;
            } else {
                return args[0];
            }
        });
    } catch (error) {
        console.log(error);
        return false;
    }
}

//如果外边需要才导出这个
export function* onRequestData(action) {
    let data = action.payload;
    let currentState = yield select((state) => state.courseList);
    //如果已经在loading了没必要在发了
    if (!currentState.loading) {
        yield put({
            type: actionType.SAMPLE_AJAX_START,
            payload: {
                foo: 'foo'
            }
        });
    }

    let searchData = yield call(requestData, {});
    if (searchData) {
        yield put({
            type: actionType.SAMPLE_AJAX_SUCCESS,
            payload: {
                foo: 'foo'
            }
        });
    } else {
        yield put({
            type: actionType.SAMPLE_AJAX_FAIL,
            payload: {
                foo: 'foo'
            }
        });
    }
}

export default function* () {
    yield takeLatest(actionType.SAMPLE_AJAX, onRequestData);
}
